/*
    Yin 3D Game Engine
    Copyright (C) 2020 Mark Sowden <hogsy@oldtimes-software.com>

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/
/* Copyright (C) 2020 Mark Sowden <markelswo@gmail.com>
 * Project Yin
 * */

#include "yin.h"
#include "actor.h"

typedef struct ATriggerVolume {
	bool removeOnTrigger;
} ATriggerVolume;

void TriggerVolume_Spawn( Actor *self ) {
	ATriggerVolume *triggerData = Sys_calloc( 1, sizeof( ATriggerVolume ) );
	Act_SetUserData( self, triggerData );
}

void TriggerVolume_Collide( Actor *self, Actor *other, void *userData ) {
	ATriggerVolume *triggerData = ( ATriggerVolume * ) userData;

	/* if we're flagged for destruction, go ahead once we're done */
	if ( triggerData->removeOnTrigger ) {
		Act_DestroyActor( self );
	}
}
