/*
    Yin 3D Game Engine
    Copyright (C) 2020 Mark Sowden <hogsy@oldtimes-software.com>

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/
/* Copyright (C) 2020 Mark E Sowden <markelswo@gmail.com> */

#include <SDL2/SDL_audio.h>

#include "yin.h"
#include "audio.h"

typedef struct AudioSample {

} AudioSample;

static SDL_AudioSpec audioSpec;
static SDL_AudioDeviceID audioDeviceID;

void Audio_Initialize( void ) {
	SDL_AudioSpec desiredSpec;
	memset( &desiredSpec, 0, sizeof( SDL_AudioSpec ) );
	desiredSpec.channels = 2;
	desiredSpec.format = AUDIO_F32;
	desiredSpec.freq = 48000;
	desiredSpec.samples = 4096;
	desiredSpec.callback = NULL;

	audioDeviceID = SDL_OpenAudioDevice( NULL, 0, &desiredSpec, &audioSpec, SDL_AUDIO_ALLOW_FORMAT_CHANGE );
	if ( audioDeviceID == 0 ) {
		PrintWarn( "Failed to open audio device!\nSDL: %s\n", SDL_GetError() );
		return;
	}
}

void Audio_Shutdown( void ) {
	SDL_CloseAudioDevice( audioDeviceID );
}
