/*
    Yin 3D Game Engine
    Copyright (C) 2020 Mark Sowden <hogsy@oldtimes-software.com>

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/
/* Copyright (C) 2020 Mark Sowden <markelswo@gmail.com>
 * Project Yin
 * */

#pragma once

enum MapFaceFlags {
	PL_BITFLAG( MAP_FLAG_FACE_PORTAL, 0 ), /* face leads into other specified sector */
	PL_BITFLAG( MAP_FLAG_FACE_MIRROR, 1 ), /* face leads into sector flipped */
};

typedef struct MapFace {
	PLPolygon *polygon;
	struct Material *material;
	PLCollisionAABB bounds;
	uint8_t flags;
} MapFace;

typedef struct MapSector {
	MapFace *faces;
	unsigned int numFaces;
} MapSector;

typedef struct GfxCamera GfxCamera;

MapFace *Map_GetFacesForSector( unsigned int sectorNum, unsigned int *numFaces );
void Map_ClearData( void );

void Map_Load( const char *mapName );
void Map_Draw( GfxCamera *camera );

bool Map_CheckCollisions( const PLCollisionAABB *bounds, unsigned int curArea );
