/*
    Yin 3D Game Engine
    Copyright (C) 2020 Mark Sowden <hogsy@oldtimes-software.com>

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/
/* Copyright (C) 2020 Mark E Sowden <markelswo@gmail.com> */

#pragma once

#define MAX_MATERIAL_PASSES 4
#define MAX_MATERIAL_VARIABLES 64

/* built-in variable types */
enum {
	MATERIAL_BUILTIN_TIME,

	MAX_MATERIAL_BUILTINS
};

typedef struct Material Material;

void RM_InitializeMaterialSystem( void );
void RM_ShutdownMaterialSystem( void );

PLShaderProgram *RM_GetMaterialShaderProgram( Material *material, unsigned int pass );

/* i/o */
Material *RM_CacheMaterial( const char *path, CacheGroup group );
void RM_DestroyMaterial( Material *material );
void RM_ClearMaterials( CacheGroup group );

/* drawing */
void RM_SetMaterial( Material *material );
void RM_DrawMesh( Material *material, PLMesh *mesh );
