/*
    Yin 3D Game Engine
    Copyright (C) 2020 Mark Sowden <hogsy@oldtimes-software.com>

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/
/* Copyright (C) 2020 Mark E Sowden <markelswo@gmail.com> */

#include "yin.h"
#include "script.h"

ScriptVariableType SCR_GetVariableTypeByTag( const char *tag ) {
	typedef struct VarTag {
		const char *tag;
		ScriptVariableType type;
	} VarTag;
	static VarTag varTags[] = {
	        { "float", SCRIPT_VAR_FLOAT },
	        { "int", SCRIPT_VAR_INT },
	        { "uint", SCRIPT_VAR_UINT },
	        { "bool", SCRIPT_VAR_BOOL },
	        { "double", SCRIPT_VAR_DOUBLE },
	        { "vec2", SCRIPT_VAR_VEC2 },
	        { "vec3", SCRIPT_VAR_VEC3 },
	        { "vec4", SCRIPT_VAR_VEC4 },
	        { "string", SCRIPT_VAR_STRING },
	        { "texture", SCRIPT_VAR_TEXTURE },
	        { "builtin", SCRIPT_VAR_BUILTIN },
	};

	for ( int i = 0; i < plArrayElements( varTags ); ++i ) {
		if ( strcmp( tag, varTags[ i ].tag ) == 0 ) {
			return varTags[ i ].type;
		}
	}

	return SCRIPT_VAR_INVALID;
}
