/*
    Yin 3D Game Engine
    Copyright (C) 2020 Mark Sowden <hogsy@oldtimes-software.com>

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/
/* Copyright (C) 2020 Mark Sowden <markelswo@gmail.com>
 * Parser */

#include <stdbool.h>
#include <stdint.h>

#include "parser.h"

const char *EZP_SkipSpaces( const char *buffer ) {
	while( *buffer == ' ' ) {
		buffer++;
	}

	return buffer;
}

const char *EZP_SkipLine( const char *buffer ) {
	while( *buffer != '\0' && *buffer != '\n' ) {
		buffer++;
	}

	return ( *buffer == '\n' ) ? ++buffer : buffer;
}

/**
 * Returns NULL if string did not fit into destination.
 */
const char *EZP_ReadString( const char *buffer, char *destination, size_t length ) {
	bool isContained = false;
	if ( *buffer == '"' ) {
		isContained = true;
		buffer++;
	}

	unsigned int destPos = 0;
	while ( *buffer != '\0' ) {
		if ( ( *buffer == '\r' || *buffer == '\n' ) || ( isContained && *buffer == '"' ) || ( !isContained && *buffer == ' ' ) ) {
			buffer++;
			break;
		}

		destination[ destPos++ ] = *buffer;
		if ( destPos >= length ) {
			return NULL;
		}

		buffer++;
	}

	destination[ destPos ] = '\0';
	return EZP_SkipSpaces( buffer );
}
